#include <stdio.h>

#include <windows.h>
#include <commctrl.h>

#include "resource.h"
#include "filter.h"

extern HINSTANCE g_hInst;

extern "C" void asm_grayscale_run(
		void *dst,
		unsigned long width,
		unsigned long height,
		unsigned long stride
		);

///////////////////////////////////

int grayscale_run(const FilterActivation *fa, const FilterFunctions *ff) {	
	asm_grayscale_run(
			fa->src.data,
			fa->src.w,
			fa->src.h,
			fa->src.pitch
			);

	return 0;
}

long grayscale_param(FilterActivation *fa, const FilterFunctions *ff) {
	fa->dst.offset	= fa->src.offset;
	fa->dst.modulo	= fa->src.modulo;
	fa->dst.pitch	= fa->src.pitch;
	return 0;
}

FilterDefinition filterDef_grayscale={
	0,0,NULL,
	"grayscale",
	"Rips the color out of your image.\n\n[Assembly optimized]",
	NULL,NULL,
	0,
	NULL,NULL,
	grayscale_run,
	grayscale_param,
	NULL,
	NULL,
};